package polymorhism;

import edev.AnalogRadio;
import edev.DigitalRadio;
import edev.EDevice;
import edev.Radio;
import edev.TV;
import java.util.ArrayList;
import polymorhism2.Derivative;
import polymorhism2.Parent;

/**
 *
 * @author visitor
 */
public class Main {
    static void move(Animal a) {
        a.move();
    }
    
    static void example1() {
        //Animal a=new Animal();
        Animal d=new Dog();
        Animal b=new Bird();
        Animal f=new Fish();
        //a.move();
        d.move();
        //move(a);
        move(d);
        move(b);
        move(f);
    }
    
    void exercise2() {
        Animal[] array=new Animal[4];
        array[0]=new Bird();
        array[1]=new Dog();
        array[2]=new Bird();
        array[3]=new Fish();
        for (Animal a:array)
            a.move();
    }
    
    void exercise3() {
        
    }
    
    public static void main(String[] args) {
        EDevice r=new Radio();
        EDevice tv=new TV();
        ArrayList<EDevice> store=new ArrayList<>();
        store.add(r);
        store.add(tv);
        for (EDevice eDev:store) {
            if (eDev instanceof Radio) {}
            eDev.setPowerOn(true);
            eDev.operate();
        }
        
        Radio[] array=new Radio[3];
        array[0]=new Radio();
        array[1]=new DigitalRadio();
        array[2]=new AnalogRadio();
        
        for (Radio radio:array)
            radio.operate();
            
    }
    
}
